package umdes;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;
import java.util.Comparator;
import java.util.Vector;

public class Window implements Transferable { 
	
	public int n;
	public Vector<String> s;
	public RegExpr e;
	public State state;
	public static boolean reverse = false;
	protected static Vector transferableWindows = new Vector();
	
	protected Vector states_traveled_through;
	
	public Window(State state_input, int num, Vector<String> string, RegExpr r_in){
		n = num;
		state = state_input;
		s = string;
		e = r_in;
	}
	
	
	
	public boolean equals(Object o){
		
		if(o==null)return false;
		Window w_tmp;
		if (o instanceof Window) {
			w_tmp = (Window) o;
		}
		else return false;	
		if(this.n!=w_tmp.n ) return false;
		if(!this.e.equals(w_tmp.e)) return false;
		if(!this.state.equals(w_tmp.state)) return false;
		if(!this.s.equals(w_tmp.s)) return false;
		
		return true;
	
	}

	public int hashCode(){
		int hash = 0;
		hash = n + s.hashCode() + e.hashCode() + state.hashCode();
		return hash;
	}
	
	public String toString() {
		String str  = "";
		if(n > 1 && (s==null||s.size()==0)) {
			str += "{" + e.getExpression() + "}"; 
			return str;
		}
		str  = "(";
		for(int i = 0; i < s.size(); i++){
			str += s.toString();
		}
		if(s.size() > 0) str += "," + state.getName() + "," + e.getExpression() + ")";
		else str +=   state.getName() + "," + e.getExpression() + ")";
		
		return str;
	}


	
/**
 * Gets a comparator for events for the Window class
 * 
 * @param reverse_in:  the comparator will sort by the reverse order
 * @return the Comparator
 */
	public static Comparator getComparatorState(boolean reverse_in){
		compareStates_win c = new compareStates_win();
		reverse = reverse_in;
		return c;
	}
	
	private static class compareStates_win implements Comparator{
		
		public int compare(Object obj1, Object obj2){
			
			Window w1 = (Window) obj1;
			Window w2 = (Window) obj2;
			if(reverse==true){
				return w1.state.getName().compareTo(w2.state.getName()) * -1;
			}
			else return w1.state.getName().compareTo(w2.state.getName());
		}
	}	
/**
 * Gets a comparator for events for the Window class
 * 
 * @param reverse_in:  the comparator will sort by the reverse order
 * @return the Comparator
 */
	public static Comparator getComparatorEvent(boolean reverse_in){
		compareEvents_win c = new compareEvents_win();
		reverse = reverse_in;
		return c;
	}
	
    private static class compareEvents_win implements Comparator{

    	//public boolean reverse = false;
    	public int compare(Object obj1, Object obj2){

    		Window w1 = (Window) obj1;
    		Window w2 = (Window) obj2;
    		if(reverse==true){
    			return w1.e.getExpression().compareTo(w2.e.getExpression()) * -1;
    		}
    		else return w1.e.getExpression().compareTo(w2.e.getExpression());
    	}
    }
    
    public DataFlavor[] getTransferDataFlavors(){
    	DataFlavor[] d = new DataFlavor[1];
    	d[0] = new DataFlavor(this.getClass(), "Window");
    	return d;
    }
    public boolean isDataFlavorSupported(DataFlavor flavor){
    	if(flavor.getHumanPresentableName().equals("Window")) return true;
    	else return false;
    }
    public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
    	if(flavor.getHumanPresentableName().equals("Window")) return this;
    	else throw new UnsupportedFlavorException(flavor);  	
    }
    

}
